<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tigl.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_94a155f7dc2906c9779926ac0a1b29ad.html">api</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tigl.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tigl_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGL_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGL_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &lt;time.h&gt;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &lt;math.h&gt;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#include  &lt;stdint.h&gt;</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglUtils_8hpp.html">tiglUtils.hpp</a>&quot;</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglRW_8hpp.html">tiglRW.hpp</a>&quot;</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglUtilsMacros_8h.html">tiglUtilsMacros.h</a>&quot;</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglContainersSubgraph_8hpp.html">tiglContainersSubgraph.hpp</a>&quot;</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCommunication_8hpp.html">tiglCommunication.hpp</a>&quot;</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglComputationManager_8hpp.html">tiglComputationManager.hpp</a>&quot;</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglMutationManager_8hpp.html">tiglMutationManager.hpp</a>&quot;</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglUtilsMpiTools_8h.html">tiglUtilsMpiTools.h</a>&quot;</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglUtilsOmpTools_8h.html">tiglUtilsOmpTools.h</a>&quot;</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor">#include &lt;set&gt;</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor">#include &lt;unistd.h&gt;</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="comment"> * namespaces</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment"> * TIGL class</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ALG_VERTEX_TYPE, <span class="keyword">typename</span> ALG_COMBINER&gt;</div>
<div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="classTIGL.html">   88</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGL.html">TIGL</a></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;{</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> ALG_VERTEX_TYPE::MESSAGE_TYPE ALG_MESSAGE_TYPE;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> ALG_VERTEX_TYPE::EDGE_TYPE EDGE_TYPE;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> ALG_VERTEX_TYPE::INIT_TYPE ALG_INIT;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="classTIGLContainersSubgraph.html">TIGLContainersSubgraph&lt;ALG_VERTEX_TYPE, ALG_MESSAGE_TYPE&gt;</a> <a class="code" href="classTIGLContainersSubgraph.html">SUBGRAPH_TYPE</a>;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="classTIGLCommunicationManager.html">TIGLCommunicationManager&lt;SUBGRAPH_TYPE&gt;</a> <a class="code" href="classTIGLCommunicationManager.html">COMMUNICATOR_TYPE</a>;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="classTIGLComputationManager.html">TIGLComputationManager&lt;SUBGRAPH_TYPE, ALG_COMBINER, ALG_INIT&gt;</a> <a class="code" href="classTIGLComputationManager.html">COMPUTATION_TYPE</a>;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="classTIGLMutationManager.html">TIGLMutationManager&lt;SUBGRAPH_TYPE&gt;</a> <a class="code" href="classTIGLMutationManager.html">MUTATION_TYPE</a>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> ALG_VERTEX_TYPE::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> SUBGRAPH_TYPE::MESSAGE_BUF_TYPE MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> SUBGRAPH_TYPE::VERTEX_ITERATOR VERTEX_ITERATOR;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> ALG_VERTEX_TYPE::ALG_DATA_TYPE ALG_DATA_TYPE;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;   <span class="keyword">typedef</span> MESSAGE_BUF_TYPE EXTERNAL_MESSAGE_BUF;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="comment">    * Attributes</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;   <span class="comment">// params</span></div>
<div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="classTIGL.html#a1928633793d2b130d62b93a6999fb415">  117</a></span>&#160;<span class="comment"></span>   uint_fast32_t <a class="code" href="classTIGL.html#a1928633793d2b130d62b93a6999fb415">rank</a>;</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;   <span class="comment">// engine managers</span></div>
<div class="line"><a name="l00120"></a><span class="lineno"><a class="line" href="classTIGL.html#a59fcdfd2bacee67418e182f347f898f7">  120</a></span>&#160;<span class="comment"></span>   <a class="code" href="classTIGLContainersSubgraph.html">SUBGRAPH_TYPE</a> *<a class="code" href="classTIGL.html#a59fcdfd2bacee67418e182f347f898f7">dataManager</a>;</div>
<div class="line"><a name="l00122"></a><span class="lineno"><a class="line" href="classTIGL.html#a350034bc25d3ef9fc5427c01eb51b280">  122</a></span>&#160;   <a class="code" href="classTIGLCommunicationManager.html">COMMUNICATOR_TYPE</a> *<a class="code" href="classTIGL.html#a350034bc25d3ef9fc5427c01eb51b280">communicationManager</a>;</div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="classTIGL.html#a38c56842f9838f3c58f7fd15fc6c6bf7">  124</a></span>&#160;   <a class="code" href="classTIGLComputationManager.html">COMPUTATION_TYPE</a> *<a class="code" href="classTIGL.html#a38c56842f9838f3c58f7fd15fc6c6bf7">computationManager</a>;</div>
<div class="line"><a name="l00126"></a><span class="lineno"><a class="line" href="classTIGL.html#a5541f512541b62a53b718520ba942625">  126</a></span>&#160;   ALG_COMBINER *<a class="code" href="classTIGL.html#a5541f512541b62a53b718520ba942625">combiner</a>;</div>
<div class="line"><a name="l00128"></a><span class="lineno"><a class="line" href="classTIGL.html#acd9412890896557621ab288764a83f44">  128</a></span>&#160;   <a class="code" href="classTIGLMutationManager.html">MUTATION_TYPE</a> *<a class="code" href="classTIGL.html#acd9412890896557621ab288764a83f44">mutationManager</a>;</div>
<div class="line"><a name="l00130"></a><span class="lineno"><a class="line" href="classTIGL.html#affa2deafa252a76aabf16e1b52c5992d">  130</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGL.html#affa2deafa252a76aabf16e1b52c5992d">numDevices</a>;</div>
<div class="line"><a name="l00132"></a><span class="lineno"><a class="line" href="classTIGL.html#aff8f26ab7c900ed74baa523afc72f369">  132</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGL.html#aff8f26ab7c900ed74baa523afc72f369">numLocalVertices</a>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div>
<div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="classTIGL.html#ac7f5c28d16a3566f413010d3e242167e">  135</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGL.html#ac7f5c28d16a3566f413010d3e242167e">numTotalVertices</a>;</div>
<div class="line"><a name="l00137"></a><span class="lineno"><a class="line" href="classTIGL.html#abb3c1874d24580f08b4794d7b3e1fd8b">  137</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGL.html#abb3c1874d24580f08b4794d7b3e1fd8b">flagDirected</a>;</div>
<div class="line"><a name="l00139"></a><span class="lineno"><a class="line" href="classTIGL.html#a64fdb2311577f9179f9180124336e6fd">  139</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGL.html#a64fdb2311577f9179f9180124336e6fd">algorithmRunning</a>;</div>
<div class="line"><a name="l00141"></a><span class="lineno"><a class="line" href="classTIGL.html#aef38bee1457371fb710a3146bff6fc6f">  141</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGL.html#aef38bee1457371fb710a3146bff6fc6f">countSS</a>;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;   <a class="code" href="classTIGL.html">TIGL</a>(<span class="keywordtype">bool</span> isDirected, uint64_t totalVertices, uint_fast32_t idDevice = 0, uint_fast32_t totalDevices = 1, <span class="keywordtype">int</span> allocThreads = NUM_OMP_THREADS);</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;   ~<a class="code" href="classTIGL.html">TIGL</a>();</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;<span class="comment">    * class internal methods</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;   uint_fast32_t mutateProcessOneLine(<span class="keywordtype">string</span> localLine, uint_fast32_t *numMessages);</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;   <span class="keywordtype">bool</span> mutateDistributedGraphFromFile(<span class="keywordtype">char</span> *fileName);</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;   <span class="keywordtype">bool</span> remoteMutateDistributedGraph(uint_fast32_t readDev);</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;   <span class="keywordtype">bool</span> computeTask(uint_fast32_t maxSS, ALG_INIT *initParams);</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;   <span class="keywordtype">void</span> txTask();</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;   <span class="keywordtype">void</span> rxTask();</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="comment">    * class public methods</span></div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;   <span class="keywordtype">void</span> reset();</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;   <span class="keywordtype">bool</span> networkReadGraph(uint_fast32_t readDev, <span class="keywordtype">char</span> *fileName = NULL);</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;   <span class="keywordtype">bool</span> mutateLocalSubgraphFromFile(<span class="keywordtype">char</span> *fileName);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;   <span class="keywordtype">bool</span> readSubgraphFromFile(<span class="keywordtype">char</span> *fileName);</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;   <span class="keywordtype">void</span> initGraph(vector&lt;ALG_VERTEX_TYPE&gt; &amp; vertexList);</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;   <span class="keywordtype">bool</span> run(uint_fast32_t maxSS = DEFAULT_MAXIMUM_SS, ALG_INIT *initParams = 0);</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt; <span class="keywordtype">double</span> computeSNR(vector&lt;CVertex&gt; &amp; refVect);</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt; <span class="keywordtype">double</span> computeNormalizedSNR(vector&lt;CVertex&gt; &amp; refVect);</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt; <span class="keywordtype">double</span> computeMSE(vector&lt;CVertex&gt; &amp; refVect);</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;   uint_fast32_t memoryUsage();</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;   uint_fast32_t getNumVertices();</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;   ID_TYPE getNumEdges();</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;   uint_fast32_t MaxCollision();</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;   <span class="keyword">inline</span> uint_fast32_t numSS();</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="preprocessor">#ifdef DEBUG_ENABLE</span></div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;   <span class="keywordtype">void</span> printBuffers();</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;   <span class="keywordtype">void</span> printAlgData();</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;   <span class="keywordtype">bool</span> printAlgData2File(<span class="keywordtype">char</span> *fileName);</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="preprocessor">#ifdef  PROFILE_ENABLE</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;   <span class="keywordtype">void</span> PrintProfilingInfo();</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;};</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglImplementation_8hpp.html">tiglImplementation.hpp</a>&quot;</span></div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGL_HPP_ */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div>
<div class="ttc" id="classTIGL_html_a59fcdfd2bacee67418e182f347f898f7"><div class="ttname"><a href="classTIGL.html#a59fcdfd2bacee67418e182f347f898f7">TIGL::dataManager</a></div><div class="ttdeci">SUBGRAPH_TYPE * dataManager</div><div class="ttdoc">pointer to TIGLContainersSubgraph object (allocated in the constructor) </div><div class="ttdef"><b>Definition:</b> tigl.hpp:120</div></div>
<div class="ttc" id="classTIGL_html_ac7f5c28d16a3566f413010d3e242167e"><div class="ttname"><a href="classTIGL.html#ac7f5c28d16a3566f413010d3e242167e">TIGL::numTotalVertices</a></div><div class="ttdeci">uint_fast32_t numTotalVertices</div><div class="ttdoc">total number of vertices in the graph </div><div class="ttdef"><b>Definition:</b> tigl.hpp:135</div></div>
<div class="ttc" id="tiglUtilsMacros_8h_html"><div class="ttname"><a href="tiglUtilsMacros_8h.html">tiglUtilsMacros.h</a></div></div>
<div class="ttc" id="classTIGLMutationManager_html"><div class="ttname"><a href="classTIGLMutationManager.html">TIGLMutationManager</a></div><div class="ttdoc">Mutation manager class. </div><div class="ttdef"><b>Definition:</b> tiglMutationManager.hpp:57</div></div>
<div class="ttc" id="classTIGLCommunicationManager_html"><div class="ttname"><a href="classTIGLCommunicationManager.html">TIGLCommunicationManager</a></div><div class="ttdoc">Core communicator class definition. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationManager.hpp:84</div></div>
<div class="ttc" id="classTIGL_html_a64fdb2311577f9179f9180124336e6fd"><div class="ttname"><a href="classTIGL.html#a64fdb2311577f9179f9180124336e6fd">TIGL::algorithmRunning</a></div><div class="ttdeci">bool algorithmRunning</div><div class="ttdoc">true if the algorithm is running, otherwise false </div><div class="ttdef"><b>Definition:</b> tigl.hpp:139</div></div>
<div class="ttc" id="classTIGL_html_abb3c1874d24580f08b4794d7b3e1fd8b"><div class="ttname"><a href="classTIGL.html#abb3c1874d24580f08b4794d7b3e1fd8b">TIGL::flagDirected</a></div><div class="ttdeci">bool flagDirected</div><div class="ttdoc">directed/undirected graph </div><div class="ttdef"><b>Definition:</b> tigl.hpp:137</div></div>
<div class="ttc" id="tiglImplementation_8hpp_html"><div class="ttname"><a href="tiglImplementation_8hpp.html">tiglImplementation.hpp</a></div></div>
<div class="ttc" id="classTIGL_html_aef38bee1457371fb710a3146bff6fc6f"><div class="ttname"><a href="classTIGL.html#aef38bee1457371fb710a3146bff6fc6f">TIGL::countSS</a></div><div class="ttdeci">uint_fast32_t countSS</div><div class="ttdoc">the superstep counter </div><div class="ttdef"><b>Definition:</b> tigl.hpp:141</div></div>
<div class="ttc" id="tiglComputationManager_8hpp_html"><div class="ttname"><a href="tiglComputationManager_8hpp.html">tiglComputationManager.hpp</a></div></div>
<div class="ttc" id="classTIGL_html"><div class="ttname"><a href="classTIGL.html">TIGL</a></div><div class="ttdoc">Top level class for the TIGL engine  . </div><div class="ttdef"><b>Definition:</b> tigl.hpp:88</div></div>
<div class="ttc" id="tiglCommunication_8hpp_html"><div class="ttname"><a href="tiglCommunication_8hpp.html">tiglCommunication.hpp</a></div></div>
<div class="ttc" id="tiglMutationManager_8hpp_html"><div class="ttname"><a href="tiglMutationManager_8hpp.html">tiglMutationManager.hpp</a></div></div>
<div class="ttc" id="tiglUtils_8hpp_html"><div class="ttname"><a href="tiglUtils_8hpp.html">tiglUtils.hpp</a></div></div>
<div class="ttc" id="classTIGL_html_acd9412890896557621ab288764a83f44"><div class="ttname"><a href="classTIGL.html#acd9412890896557621ab288764a83f44">TIGL::mutationManager</a></div><div class="ttdeci">MUTATION_TYPE * mutationManager</div><div class="ttdoc">pointer to TIGLMutationManager object (allocated in the constructor) </div><div class="ttdef"><b>Definition:</b> tigl.hpp:128</div></div>
<div class="ttc" id="classTIGL_html_a5541f512541b62a53b718520ba942625"><div class="ttname"><a href="classTIGL.html#a5541f512541b62a53b718520ba942625">TIGL::combiner</a></div><div class="ttdeci">ALG_COMBINER * combiner</div><div class="ttdoc">pointer to user-defined combiner object (allocated in the constructor) </div><div class="ttdef"><b>Definition:</b> tigl.hpp:126</div></div>
<div class="ttc" id="classTIGLContainersSubgraph_html"><div class="ttname"><a href="classTIGLContainersSubgraph.html">TIGLContainersSubgraph</a></div><div class="ttdoc">Graph container for each device in the TIGL. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraph.hpp:76</div></div>
<div class="ttc" id="classTIGL_html_a38c56842f9838f3c58f7fd15fc6c6bf7"><div class="ttname"><a href="classTIGL.html#a38c56842f9838f3c58f7fd15fc6c6bf7">TIGL::computationManager</a></div><div class="ttdeci">COMPUTATION_TYPE * computationManager</div><div class="ttdoc">pointer to TIGLComputationManager object (allocated in the constructor) </div><div class="ttdef"><b>Definition:</b> tigl.hpp:124</div></div>
<div class="ttc" id="tiglRW_8hpp_html"><div class="ttname"><a href="tiglRW_8hpp.html">tiglRW.hpp</a></div></div>
<div class="ttc" id="classTIGL_html_a1928633793d2b130d62b93a6999fb415"><div class="ttname"><a href="classTIGL.html#a1928633793d2b130d62b93a6999fb415">TIGL::rank</a></div><div class="ttdeci">uint_fast32_t rank</div><div class="ttdoc">ID of the current device. </div><div class="ttdef"><b>Definition:</b> tigl.hpp:117</div></div>
<div class="ttc" id="tiglUtilsMpiTools_8h_html"><div class="ttname"><a href="tiglUtilsMpiTools_8h.html">tiglUtilsMpiTools.h</a></div></div>
<div class="ttc" id="classTIGLComputationManager_html"><div class="ttname"><a href="classTIGLComputationManager.html">TIGLComputationManager</a></div><div class="ttdoc">Core Computation class for the TIGL. </div><div class="ttdef"><b>Definition:</b> tiglComputationManager.hpp:76</div></div>
<div class="ttc" id="classTIGL_html_aff8f26ab7c900ed74baa523afc72f369"><div class="ttname"><a href="classTIGL.html#aff8f26ab7c900ed74baa523afc72f369">TIGL::numLocalVertices</a></div><div class="ttdeci">uint_fast32_t numLocalVertices</div><div class="ttdoc">number of local vertices </div><div class="ttdef"><b>Definition:</b> tigl.hpp:132</div></div>
<div class="ttc" id="classTIGL_html_a350034bc25d3ef9fc5427c01eb51b280"><div class="ttname"><a href="classTIGL.html#a350034bc25d3ef9fc5427c01eb51b280">TIGL::communicationManager</a></div><div class="ttdeci">COMMUNICATOR_TYPE * communicationManager</div><div class="ttdoc">pointer to TIGLCommunicationManager object (allocated in the constructor) </div><div class="ttdef"><b>Definition:</b> tigl.hpp:122</div></div>
<div class="ttc" id="tiglUtilsOmpTools_8h_html"><div class="ttname"><a href="tiglUtilsOmpTools_8h.html">tiglUtilsOmpTools.h</a></div></div>
<div class="ttc" id="classTIGL_html_affa2deafa252a76aabf16e1b52c5992d"><div class="ttname"><a href="classTIGL.html#affa2deafa252a76aabf16e1b52c5992d">TIGL::numDevices</a></div><div class="ttdeci">uint_fast32_t numDevices</div><div class="ttdoc">total number of devices (1 if MPI is not used) </div><div class="ttdef"><b>Definition:</b> tigl.hpp:130</div></div>
<div class="ttc" id="tiglContainersSubgraph_8hpp_html"><div class="ttname"><a href="tiglContainersSubgraph_8hpp.html">tiglContainersSubgraph.hpp</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:51 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
